﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Olap.Xmla;
using Infragistics.Olap.Data;
using Infragistics.Olap;

namespace Pivot_Analysis
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        XmlaDataSource datasource;
        public MainWindow()
        {
            InitializeComponent();

            datasource = new XmlaDataSource() { ServerUri = new Uri("http://sampledata.infragistics.com/olap/msmdpump.dll") };
            datasource.Database = XmlaDataSource.GenerateInitialDatabase("Adventure Works DW Standard Edition");
            datasource.Cube = XmlaDataSource.GenerateInitialCube("Adventure Works");
            datasource.Initialized += new EventHandler<EventArgs>(datasource_Initialized);
            datasource.LoadSchemaAsync();
            
        }

        void datasource_Initialized(object sender, EventArgs e)
        {
            IHierarchy dateCalendar = datasource.Cube.Dimensions.
                SelectMany(d => d.Hierarchies).
                FirstOrDefault(h => h.Caption =="City"&& h.AllMember.Contains("Geography") );

            FilterViewModelBase filterViewModel = (FilterViewModelBase)datasource.CreateFilterViewModel(dateCalendar);
            
            filterViewModel.AttachToProvider();

            filterViewModel.LoadFilterMembersCompleted += this.FilterViewModel_LoadFilterMembersCompleted;
            filterViewModel.DataProvider.LoadMembersAsync(this.datasource.Cube, dateCalendar);
        }

        private void FilterViewModel_LoadFilterMembersCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            IHierarchy hierarchy = e.UserState as IHierarchy;
            if (hierarchy != null)
            {
                FilterViewModelBase filterViewModel = (FilterViewModelBase)sender;
                filterViewModel.LoadFilterMembersCompleted -= this.FilterViewModel_LoadFilterMembersCompleted;

                datasource.ResultChanged += this.Datasource_ResultChanged;
                datasource.Rows.Add(filterViewModel);
            }
        }

        private void Datasource_ResultChanged(object sender, ResultChangedEventArgs e)
        {
            xamPivotGrid1.DataSource = datasource;
            xamPivotDataSelector1.DataSource = datasource;
        }
    }
}
